Subject: NNCP with SP via high-latency links and TCP timeouts

From: Marek Küthe <[email-masked]>
Date: Sat, 18 Jan 2025 11:15:52 +0000

Hello,

I recently came across NNCP and on the homepage it says that it also
works over high latency links, but TCP is used. When I tried to
establish a TCP connection with netcat via a high-latency link (20%
packet loss, 30 seconds latency), I got a lot of timeouts and
retransmissions, so that the TCP connection was not established at all.

I have two questions about this:
- Does NNCP SP also work over UDP?

- I looked at the source code and saw that various timeouts are set.
  However, I found on [1] that only the timeouts for the connection and
  not the TCP handshake (which is started in call.go line 91) are set.
  Is this intentional? Have I overlooked something?

I would appreciate an answer!

Regards
Marek Küthe

[1] https://stackoverflow.com/questions/63870817/does-setting-the-timeout-on-the-net-dialer-and-deadline-on-the-connection-result